"use strict";
const ServerUsD = server.registerSystem(0, 0);
ServerUsD.playersOnline = [];
ServerUsD.initialize = function () {
    this.listenForEvent("UpsideDown:client_entered_world", (eventData) => this.playerEntered(eventData.data.player));
    this.listenForEvent("minecraft:entity_created", (eventData) => this.entityLoaded(eventData.data.entity));
};
ServerUsD.update = function () {
    for (let i in this.playersOnline) {
        if (this.isValidEntity(this.playersOnline[i])) {
            const Position = this.getComponent(this.playersOnline[i], "minecraft:position");
            this.flipChunk((Math.floor(Position.data.x / 16) * 16), (Math.floor(Position.data.z / 16) * 16))
            if (Position.data.y >= 256) {
                Position.data.y = 255;
                this.applyComponentChanges(this.playersOnline[i], Position);
                const Command = this.createEventData("minecraft:execute_command");
                Position.data.y = 192;
                Command.data.command = ("/fill " + (Position.data.x - 1) + " 191 " + (Position.data.z - 1) + " " + (Position.data.x + 1) + " 194 " + (Position.data.z + 1) + " wood 0 destroy");
                this.broadcastEvent("minecraft:execute_command", Command);
                Command.data.command = ("/fill " + (Position.data.x - 1) + " 192 " + (Position.data.z - 1) + " " + (Position.data.x + 1) + " 193 " + (Position.data.z + 1) + " torch 5 destroy");
                this.broadcastEvent("minecraft:execute_command", Command);
                this.applyComponentChanges(this.playersOnline[i], Position)
            }
        } else {
            this.playersOnline.splice(i, 1);
            const Message = this.createEventData("minecraft:display_chat_event");
            Message.data.message = "Upside Down detected a player leaving";
            this.broadcastEvent("minecraft:display_chat_event", Message)
        }
    }
};
ServerUsD.playerEntered = function (player) {
    ServerUsD.playersOnline.push(player);
    const Message = this.createEventData("minecraft:display_chat_event");
    Message.data.message = "A new player was detected by Upside Down";
    this.broadcastEvent("minecraft:display_chat_event", Message)
};
ServerUsD.entityLoaded = function (entity) {
    if (this.isValidEntity(entity) && entity.__type__ == "entity" && entity.__identifier__ == "minecraft:falling_block") {
        const Command = this.createEventData("minecraft:execute_command");
        Command.data.command = "/execute @e[type=minecraft:falling_block] ~ ~ ~ setblock ~ ~1 ~ dirt 1 keep";
        this.broadcastEvent("minecraft:execute_command", Command);
        Command.data.command = "/execute @e[type=minecraft:falling_block] ~ ~ ~ setblock ~ ~-1 ~ dirt 1";
        this.broadcastEvent("minecraft:execute_command", Command)
    }
};
ServerUsD.flipChunk = function (x, z) {
    this.executeCommand("/testforblock " + x + " 255 " + z + " chain_command_block 0", (commandResultData) => {
        if (commandResultData.data.matches == false) {
            const Command = this.createEventData("minecraft:execute_command");
            Command.data.command = ("/setblock " + x + " 255 " + z + " chain_command_block 0");
            for (let i = 127; i >= 0; i--) {
                Command.data.command = ("/clone " + x + " " + i + " " + z + " " + (x + 15) + " " + i + " " + (z + 15) + " " + x + " " + (255 - i) + " " + z + " masked move");
                this.broadcastEvent("minecraft:execute_command", Command);
                Command.data.command = ("/execute @e[x=" + x + ",y=" + i + ",z=" + z + ",dx=15,dy=0,dz=15] ~ ~ ~ teleport @s ~ ~" + (255 - i - i) + " ~");
                this.broadcastEvent("minecraft:execute_command", Command)
            }
            Command.data.command = ("/setblock " + x + " 255 " + z + " chain_command_block 0");
            this.broadcastEvent("minecraft:execute_command", Command)
        }
    })
};
